﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Media;

namespace HaloMap
{
    public partial class SoundEditor : UserControl
    {
        public Map map;
        public Sound Sound;
        public int Choice = 0;
        public int Chunk = 0;
        SoundPlayer snd = new SoundPlayer();

        public SoundEditor(Map map)
        {
            this.map = map;
            InitializeComponent();
        }

        private void SoundEditor_Load(object sender, EventArgs e)
        {
            SoundRaw.Read(map);
            Sound = new Sound(map);
            Choices.Items.Clear();
            Chunks.Items.Clear();
            foreach (SoundChoice c in SoundRaw.Permutation.Choices)
            {
                try { Choices.Items.Add(Coconuts.Names[c.NameIndex].Name.Reference); }
                catch { }
            }

            for (int i = 0; i < SoundRaw.Permutation.Choices[0].SoundChunks.Count; i++)
            {
                Chunks.Items.Add("Sound Chunk #" + i.ToString());
            }

            try { Choices.SelectedIndex = 0; Chunks.SelectedIndex = 0; }
            catch { }
        }

        private void Choices_SelectedIndexChanged(object sender, EventArgs e)
        {
            Choice = Choices.SelectedIndex;
            Chunks.Items.Clear();
            for (int i = 0; i < SoundRaw.Permutation.Choices[Choice].SoundChunks.Count; i++)
            {
                Chunks.Items.Add("Sound Chunk #" + i.ToString());
            }
            try { Chunks.SelectedIndex = 0; }
            catch { }
        }

        private void Chunks_SelectedIndexChanged(object sender, EventArgs e)
        {
            axWindowsMediaPlayer1.URL = "";
            Chunk = Chunks.SelectedIndex;
            string path = Sound.LoadPreview(map, SoundRaw.Permutation.Choices[Choice].SoundChunks[Chunk]);
            axWindowsMediaPlayer1.URL = path;
        }

        public void Update(Map map)
        {
            this.map = map;
            Choices.Items.Clear();
            Chunks.Items.Clear();
            SoundRaw.Read(map);
            Sound = new Sound(map);
            foreach (SoundChoice c in SoundRaw.Permutation.Choices)
            {
                Choices.Items.Add(Coconuts.Names[c.NameIndex].Name.Reference);
            }

            for (int i = 0; i < SoundRaw.Permutation.Choices[0].SoundChunks.Count; i++)
            {
                Chunks.Items.Add("Sound Chunk #" + i.ToString());
            }

            try { Choices.SelectedIndex = 0; Chunks.SelectedIndex = 0; }
            catch { }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                Sound.Extract(sfd.FileName, map, SoundRaw.Permutation.Choices[Choice].SoundChunks[Chunk]);
                MessageBox.Show("Done!");
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //Todo: Injection
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //Todo: Internalization
        }

        private void button1_Click(object sender, EventArgs e)
        {
            axWindowsMediaPlayer1.URL = "";
            string path = Sound.PreviewAll(map, SoundRaw.Permutation.Choices[Choice].SoundChunks.ToArray());
            axWindowsMediaPlayer1.URL = path;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                Sound.ExtractAll(sfd.FileName, map, SoundRaw.Permutation.Choices[Choice].SoundChunks.ToArray());
                MessageBox.Show("Done!");
            }
        }
    }
}
