﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HaloMap
{
    public partial class StringID : UserControl
    {
        public string Description;
        public ScriptReference Script;
        Map map;
        bool Loaded = false;
        public int Offset;

        public StringID(ScriptReference Script, Map map, string Description)
        {
            InitializeComponent();
            this.Description = Description;
            this.Script = Script;
            this.map = map;
            this.Offset = Script.Offset;
        }

        private void StringID_Load(object sender, EventArgs e)
        {
            label1.Text = Description;
            comboBox1.Text = Script.Reference;
        }

        public void Update()
        {
            if (Script.Index > 0 && Script.Index <= map.Header.SIDCount)
            {
                comboBox1.Text = Script.Reference;
            }
            else
            {
                comboBox1.Text = "";
            }
        }

        public ScriptReference Save()
        {
            Script.Reference = comboBox1.Text;
            Script.Index = map.FindScript(Script.Reference);
            return Script;
        }

        private void comboBox1_DropDown(object sender, EventArgs e)
        {
            if (Loaded == false)
            {
                foreach (ScriptReference s in map.ScriptReferences)
                {
                    comboBox1.Items.Add(s.Reference);
                }
                Loaded = true;
            }
        }

        public void Poke(ProcessStream p, int Translation)
        {
            short I = p.ReadInt16(Offset - Translation);
            byte L = p.ReadByte(Offset - Translation + 3);
            Script.Index = I;
            Script.Length = L;
            try { Script.Reference = map.ScriptReferences[Script.Index].Reference; }
            catch { MessageBox.Show("Script Reference: " + Description + " could not be poked!"); comboBox1.Text = "ERROR"; }
            comboBox1.Text = Script.Reference;
        }
    }
}
