﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HaloMap
{
    public partial class Value : UserControl
    {
        public string Description;
        public object Object;
        public int Offset;
        public Type t;
        public int Length = 0;

        public Value(string Description, object Value, Type T, int Offset)
        {
            InitializeComponent();
            this.Description = Description;
            this.Object = Value;
            this.Offset = Offset;
            this.t = T;
            if (t == typeof(char[]))
            {
                Length = Object.ToString().Length;
            }
        }

        private void Value_Load(object sender, EventArgs e)
        {
            label1.Text = Description;
            if (t == typeof(char[]))
            {
                textBox1.Text = new string((char[])Object);
            }
            else
            {
                textBox1.Text = Object.ToString();
            }
        }

        public void Update()
        {
            if (t == typeof(char[]))
            {
                textBox1.Text = new string((char[])Object);
            }
            else
            {
                textBox1.Text = Object.ToString();
            }
        }

        public object Save()
        {
            Object = textBox1.Text;
            return Object;
        }

        public void Poke(ProcessStream p, int Translation)
        {
            if (t == typeof(byte))
            {
                Object = p.ReadByte(Offset - Translation);
            }
            else if (t == typeof(short))
            {
                Object = p.ReadInt16(Offset - Translation);
            }
            else if (t == typeof(ushort))
            {
                Object = p.ReadUInt16(Offset - Translation);
            }
            else if (t == typeof(int))
            {
                Object = p.ReadInt32(Offset - Translation);
            }
            else if (t == typeof(uint))
            {
                Object = p.ReadUInt32(Offset - Translation);
            }
            else if (t == typeof(float))
            {
                Object = p.ReadSingle(Offset - Translation);
            }
            else if (t == typeof(char[]))
            {
                Object = p.ReadString(Offset - Translation, Length);
            }

            if (t == typeof(char[]))
            {
                textBox1.Text = new string((char[])Object);
            }
            else
            {
                textBox1.Text = Object.ToString();
            }
        }
    }
}
